#include <stdio.h>
//#include <mem.h>

int n;
char cube[12][12][12];
char pulled[12][12][12];
int npulled;
int px, py, pz;

void pull(int x, int y, int z) {
	if( pulled[x][y][z] ) return;
	pulled[x][y][z] = 1;
	npulled++;
	if( cube[x+1][y][z] == cube[x][y][z] ) pull(x+1, y, z);
	if( cube[x-1][y][z] == cube[x][y][z] ) pull(x-1, y, z);
	if( cube[x][y+1][z] == cube[x][y][z] ) pull(x, y+1, z);
	if( cube[x][y-1][z] == cube[x][y][z] ) pull(x, y-1, z);
	if( cube[x][y][z+1] == cube[x][y][z] ) pull(x, y, z+1);
	if( cube[x][y][z-1] == cube[x][y][z] ) pull(x, y, z-1);
	if( cube[x+px][y+py][z+pz] ) pull(x+px, y+py, z+pz);
}

main() {
	int i, x, y, z;

	while( scanf( " %d", &n ) == 1 && n ) {
		memset(cube, 0, sizeof(cube));
		for( x = 1; x <= n; x++ )
		for( y = 1; y <= n; y++ )
		for( z = 1; z <= n; z++ )
			scanf( " %c", &cube[x][y][z] );
		for( px = -1; px <= 1; px++ )
		for( py = -1; py <= 1; py++ )
		for( pz = -1; pz <= 1; pz++ ) if( abs(px)+abs(py)+abs(pz) == 1 ) {
			for( x = 1; x <= n; x++ )
			for( y = 1; y <= n; y++ )
			for( z = 1; z <= n; z++ ) if( !cube[x+px][y+py][z+pz] ) {
				memset(pulled, 0, sizeof(pulled));
				npulled = 0;
				pull(x, y, z);
				if( npulled != n*n*n ) goto failed;
			}
		}
		printf( "Yes\n" );
		continue;
failed:	printf( "No\n" );
	}
}
